<template>
    <view>
        <view class="uni-padding-wrap">
            <view class="page-section swiper">
                <view class="page-section-spacing">
                    <swiper class="swiper" :indicator-dots="indicatorDots" :autoplay="autoplay" :interval="interval" :duration="duration">
                        <swiper-item v-for="(item,index) in imageList" :key="index" @click="goSwiper(item)">
                            <image style=" width:375px; background-color: #eeeeee;" :mode="item.mode" :src="item.src"
                        @error="imageError"></image>
                        </swiper-item>
                    </swiper>
                </view>
            </view>
        </view>
        <view class="page-body">
			<view class="uni-padding-wrap uni-common-mt">
				<view class="uni-flex uni-column">
					<view class="flex-item flex-item-V">
						<view class="btn-area">
							<navigator url="/pages/component/view/view" hover-class="navigator-hover">
								<image mode="widthFix" src="../../../static/home/view.png"
									@error="imageError"></image>
								<view class="iconBox">
									<view>
										<text></text>
									</view>
								</view>
								<text class="" selectable="false" space="false" decode="false">
									景点
								</text>
							</navigator>
							<navigator url="/pages/component/ticket/ticket" redirect hover-class="other-navigator-hover">
								<image mode="widthFix" src="../../../static/home/view.png"
									@error="imageError"></image>
								<view class="iconBox">
									<view>
										<text></text>
									</view>
								</view>
								<text class="" selectable="false" space="false" decode="false">
									门票
								</text>
							</navigator>
							<navigator url="/pages/component/hotel/hotel" hover-class="navigator-hover">
								<image mode="widthFix" src="../../../static/home/view.png"
									@error="imageError"></image>
								<view class="iconBox">
									<view>
										<text></text>
									</view>
								</view>
								<text class="" selectable="false" space="false" decode="false">
									酒店
								</text>
							</navigator>
							<navigator url="/pages/component/food/food" redirect hover-class="other-navigator-hover">
								<image mode="widthFix" src="../../../static/home/view.png"
									@error="imageError"></image>
								<view class="iconBox">
									<view>
										<text></text>
									</view>
								</view>
								<text class="" selectable="false" space="false" decode="false">
									美食
								</text>
							</navigator>
						</view>
					</view>
					<view class="flex-item flex-item-B">
						<view class="destination-title">
							<rich-text :nodes="h3"></rich-text>
							<text>|</text>
							<rich-text :nodes="h4"></rich-text>
						</view>
						<view class="destination-content">
							<view class="page-section swiper">
								<view class="page-section-spacing">
									<swiper class="swiper" :indicator-dots="indicatorDots" :autoplay="autoplay" :interval="interval" :duration="duration">
										<swiper-item v-for="(item,index) in imgList" :key="index">
											<view class="btn-area">
												<navigator v-for="(img,inde) in item.images" :key="inde" :url="img.url" hover-class="navigator-hover">
														<image style="background-color: #eeeeee;" :mode="img.mode" :src="img.src"
														@error="imageError"></image>
														<text>{{img.title}}</text>
												</navigator>
											</view>
										</swiper-item>
									</swiper>
								</view>
							</view>
							<view class="btnBox">
								<uni-tag v-for="(item,index) in tags" :key="index" :text="item.text" @click="goTab(item.url)" class="tag"></uni-tag>
							</view>
						</view>
					</view>
					<view class="flex-item flex-item-C">
						<view class="uni-flex uni-row">
							<view class="uni-tab-bar">
								<scroll-view id="tab-bar" class="uni-swiper-tab" scroll-x :scroll-left="scrollLeft">
									<view v-for="(tab,index) in tabBars" :key="tab.id" class="swiper-tab-list" :class="tabIndex==index ? 'active' : ''"
									:id="tab.id" :data-current="index" @click="tapTab">{{tab.name}}</view>
								</scroll-view>
								<swiper :current="tabIndex" :duration="300" @change="changeTab">
									<swiper-item v-for="(tab,index1) in newsitems" :key="index1">
										<scroll-view class="list" scroll-y @scrolltolower="loadMore(index1)">
											<block v-for="(newsitem,index2) in tab.data" :key="index2">
												<media-list :options="newsitem" @close="close(index1,index2)" @click="goDetail(newsitem)"></media-list>
											</block>
											<view class="uni-tab-bar-loading">
												{{tab.loadingText}}
											</view>
										</scroll-view>
									</swiper-item>
								</swiper>
							</view>
						</view>
					</view>
				</view>
        	</view>
        </view>
    </view>
</template>

<script>
	import uniTag from "@/components/uni-tag/uni-tag.vue";
	import mediaList from '@/components/tab-nvue/mediaList.vue';
	const tpl = {
		data0: {
			"datetime": "40分钟前",
			"article_type": 0,
			"title": "uni-app行业峰会频频亮相，开发者反响热烈!",
			"source": "DCloud",
			"comment_count": 639
		},
		data1: {
			"datetime": "一天前",
			"article_type": 1,
			"title": "DCloud完成B2轮融资，uni-app震撼发布!",
			"image_url": "https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg?imageView2/3/w/200/h/100/q/90",
			"source": "DCloud",
			"comment_count": 11395
		},
		data2: {
			"datetime": "一天前",
			"article_type": 2,
			"title": "中国技术界小奇迹：HBuilder开发者突破200万",
			"image_url": "https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/muwu.jpg?imageView2/3/w/200/h/100/q/90",
			"source": "DCloud",
			"comment_count": 11395
		},
		data3: {
			"article_type": 3,
			"image_list": [{
				"url": "https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/cbd.jpg?imageView2/3/w/200/h/100/q/90",
				"width": 563,
				"height": 316
			}, {
				"url": "https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/muwu.jpg?imageView2/3/w/200/h/100/q/90",
				"width": 641,
				"height": 360
			}, {
				"url": "https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg?imageView2/3/w/200/h/100/q/90",
				"width": 640,
				"height": 360
			}],
			"datetime": "5分钟前",
			"title": "uni-app 支持使用 npm 安装第三方包，生态更趋丰富",
			"source": "DCloud",
			"comment_count": 11
		},
		data4: {
			"datetime": "2小时前",
			"article_type": 4,
			"title": "uni-app 支持原生小程序自定义组件，更开放、更自由",
			"image_url": "https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/cbd.jpg?imageView2/3/w/200/h/100/q/90",
			"source": "DCloud",
			"comment_count": 69
		}
	};
	export default {
		components: {
			uniTag,
			mediaList
		},
		data() {
			return {
				imageList:[
					{
						mode: 'scaleToFill',
						text: 'aspectFill：保持纵横比缩放图片，只保证图片的短边能完全显示出来',
						src: 'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
						url:'/pages/component/swiperDetail/swiperDetail'
					},
					{
						mode: 'scaleToFill',
						text: 'aspectFill：保持纵横比缩放图片，只保证图片的短边能完全显示出来',
						src: 'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
						url:'/pages/component/swiperDetail/swiperDetail'
					},
					{
						mode: 'scaleToFill',
						text: 'aspectFill：保持纵横比缩放图片，只保证图片的短边能完全显示出来',
						src: 'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
						url:'/pages/component/swiperDetail/swiperDetail',
					}
				],	
				imgList:[
					{	
						images:[
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京不够积极的的技术的运河大森林',
								url:'/pages/component/view/view'
							},
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京运河大森林',
								url:'/pages/component/view/view'
							},
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京运河大森林',
								url:'/pages/component/view/view'
							},
						] 
					}, 
					{
						images:[
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京运河大森林',
								url:'/pages/component/view/view'
							},
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京运河大森林',
								url:'/pages/component/view/view'
							},
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京运河大森林',
								url:'/pages/component/view/view'
							},
						] 
					}, 
					{
						images:[
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京运河大森林',
								url:'/pages/component/view/view'
							},
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京运河大森林',
								url:'/pages/component/view/view'
							},
							{
								mode: 'scaleToFill',
								text: 'scaleToFill：不保持纵横比缩放图片，使图片完全适应',
								src:'https://img-cdn-qiniu.dcloud.net.cn/uniapp/images/shuijiao.jpg',
								title:'北京运河大森林',
								url:'/pages/component/view/view'
							},
						] 
					}
				],
				tags:[
					{
						text:"山西",
						url:'/pages/component/swiperDetail/swiperDetail'
					},
					{
						text:"山西",
						url:'/pages/component/swiperDetail/swiperDetail'
					},
					{
						text:"山西",
						url:'/pages/component/swiperDetail/swiperDetail'
					},
					{
						text:"山西",
						url:'/pages/component/swiperDetail/swiperDetail'
					},
					{
						text:"更多",
						url:'/pages/component/swiperDetail/swiperDetail'
					}
				],
				h3:[{
					name: 'h3',
					attrs: {
						class: 'h3-class',
						style: 'line-height: 60rpx; text-align:left;'
					},
					children: [{
						type: 'text',
						text: '目的地推荐'
					}]
				}],
				h4:[{
					name: 'h4',
					attrs: {
						class: 'h4-class',
						style: 'line-height: 60rpx; color: red; text-align:left;'
					},
					children: [{
						type: 'text',
						text: '精选推荐好玩的景区、城市'
					}]
				}],
				scrollLeft: 0,
				isClickChange: false,
				tabIndex: 0,
				newsitems: [],
				tabBars: [
					{
					name: '周边游',
						id: 'guanzhu'
					}, {
						name: '国内热门',
						id: 'tuijian'
					}
				],
				background: ['color1', 'color2', 'color3'],
				indicatorDots: true,
				autoplay: true,
				interval: 2000,
				duration: 500
			}
		},
		onLoad() {
			this.newsitems = this.randomfn()
		},
		created(){
			
		},
		methods: {
			goSwiper(val){
				uni.navigateTo({
					url:val.url
				});
			},
			imageError(e) {
				console.error('image发生error事件，携带值为' + e.detail.errMsg)
			},
			goTab(url){
				uni.navigateTo({
					url:url
				})
			},
			changeIndicatorDots(e) {
				this.indicatorDots = !this.indicatorDots
			},
			changeAutoplay(e) {
				this.autoplay = !this.autoplay
			},
			intervalChange(e) {
				this.interval = e.target.value
			},
			durationChange(e) {
				this.duration = e.target.value
			},
			goDetail(e) {
				uni.navigateTo({
					
				});
			},
			close(index1, index2) {
				uni.showModal({
					content: '是否删除本条信息？',
					success: (res) => {
						if (res.confirm) {
							this.newsitems[index1].data.splice(index2, 1);
						}
					}
				})
			},
			loadMore(e) {
				setTimeout(() => {
					this.addData(e);
				}, 1200);
			},
			addData(e) {
				
				if (this.newsitems[e].data.length > 30) {
					this.newsitems[e].loadingText = '没有更多了';
					return;
				}
				for (let i = 1; i <= 10; i++) {
					this.newsitems[e].data.push(tpl['data' + Math.floor(Math.random() * 5)]);
				}
			},
			async changeTab(e) {
				
				let index = e.target.current;
				if (this.newsitems[index].data.length === 0) {
					this.addData(index)
				}
				if (this.isClickChange) {
					this.tabIndex = index;
					this.isClickChange = false;
				}
				let tabBar = await this.getElSize("tab-bar"),
					tabBarScrollLeft = tabBar.scrollLeft;
				let width = 0;

				for (let i = 0; i < index; i++) {
					let result = await this.getElSize(this.tabBars[i].id);
					width += result.width;
				}
				let winWidth = uni.getSystemInfoSync().windowWidth,
					nowElement = await this.getElSize(this.tabBars[index].id),
					nowWidth = nowElement.width;
				if (width + nowWidth - tabBarScrollLeft > winWidth) {
					this.scrollLeft = width + nowWidth - winWidth;
				}
				if (width < tabBarScrollLeft) {
					this.scrollLeft = width;
				}
				this.isClickChange = false;
				this.tabIndex = index; //一旦访问data就会出问题
			},
			getElSize(id) { //得到元素的size
				return new Promise((res, rej) => {
					uni.createSelectorQuery().select("#" + id).fields({
						size: true,
						scrollOffset: true
					}, (data) => {
						res(data);
					}).exec();
				})
			},
			async tapTab(e) {
				let tabIndex = e.target.dataset.current;
				if (this.newsitems[tabIndex].data.length === 0) {
					this.addData(tabIndex)
				}
				if (this.tabIndex === tabIndex) {
					return false;
				} else {
					let tabBar = await this.getElSize("tab-bar"),
						tabBarScrollLeft = tabBar.scrollLeft; //点击的时候记录并设置scrollLeft
					this.scrollLeft = tabBarScrollLeft;
					this.isClickChange = true;
					this.tabIndex = tabIndex;
				}
			},
			randomfn() {
				let ary = [];
				for (let i = 0, length = this.tabBars.length; i < length; i++) {
					let aryItem = {
						loadingText: '加载更多...',
						data: []
					};
					if (i < 1) {
						for (let j = 1; j <= 10; j++) {
							aryItem.data.push(tpl['data' + Math.floor(Math.random() * 5)]);
						}
					}
					ary.push(aryItem);
				}
				return ary;
			}
		}
	}
</script>

<style lang="less">
	page {
		height: auto;
		min-height: 100%;
	}
	.uni-padding-wrap{
		width: 100%;
		padding: 0;
	}
	.page-body{
		width: 100%;
		.uni-common-mt{
			margin-top:0rpx;
			.uni-column{
				.flex-item{
					margin-top:30rpx;
					padding:30rpx;
					background-color:#fff;
					.btn-area{
						height:100%;
						width:100%;
						flex-direction: row;
						navigator{
							flex:1;
							padding: 40rpx 25rpx;
							position: relative;
							image{
								width: 100%;
							}
							.iconBox{
								position: absolute;
								bottom: 87rpx;
								right: 20rpx;
								width: 80rpx;
								height: 80rpx;
								padding: 10rpx;
								border-radius:50%;
								background-color:#fff;
								view{
									width: 100%;
									height: 100%;
									border-radius: 50%;
									text{
										display:block;
										position:absolute;
										bottom:20rpx;
										left:23rpx;
										margin: 0 auto;
										background:url(../../../static/home/img.png) no-repeat;
										background-size:158rpx 40rpx;
									}
								}
							}
							text{
								margin-left:40rpx;
							}
						}
						&>navigator:nth-of-type(1) .iconBox view{
							background: #00aeff;
							text{
								height: 38rpx;
								width: 32rpx;
								background-position: -84rpx 0;
							}
						}
						&>navigator:nth-of-type(2) .iconBox view{
							background: #1dd6ac;
							text{
								height: 29rpx;
								width: 38rpx;
								background-position: -49rpx 0;
							}
						}
						&>navigator:nth-of-type(3) .iconBox view{
							background: #ffa506;
							text{
								height: 38rpx;
								width: 32rpx;
								background-position: -18rpx 0;
							}
						}
						&>navigator:nth-of-type(4) .iconBox view{
							background: #fe4e50;
							text{
								height: 40rpx;
								width: 45rpx;
								background-position: -116rpx 0;
							}
						}
					}
					.destination-content{
						.btn-area{
							navigator{
								width: 33%;
								height: 60%;
								padding:40rpx 0;  
								border-radius: 20rpx;
								image{
									height: 80%;
									width: 90%;
									border-radius: 20rpx;
								}
								text{
									display:inline-block;
									width: 90%;
									overflow: hidden;
									padding: 10rpx;
									text-overflow: ellipsis; 
									white-space: nowrap;
									margin-left: -10rpx;

								}
							}
						}
						.btnBox{
							display: block;
							.tag{
								margin-right: 10rpx;
							}
						}
					}
				}
				.flex-item-B{
					display: block;
					.destination-title{
						display: inline-block;
						rich-text{
							display:inline-block;
							margin-right:10px;
						}
						& rich-text:nth-of-type(2){
							margin-top:10rpx;
						}
						text{
							margin-right:10px;
							margin-top:10rpx;
						}
					}
				}
				.flex-item-C{
					.uni-tab-bar{
						.uni-swiper-tab{
							display: flex;
							.swiper-tab-list{
								flex: 1;
								width:50%;
							}
						}
						swiper{
							height: 600rpx;
						}
					}
					.uni-tab-bar-loading {
						text-align: center;
						font-size: 28upx;
						color: #999;
					}
				}
				view:first-of-type{
					margin-top:0;
				}
			}
		}
	}
</style>
